#include "StdAfx.h"
#include "StdArx.h"

//-----------------------------------------------------------------------------
int MtmdLoadDll()
{
	resbuf *pArg =acedGetArgs ();

	typedef int (__stdcall *pUserFunc)();
	BOOL havestrres=false, havelongres=false;
	pUserFunc pFunc=NULL;
	struct resbuf *res_list;
    HMODULE mylib;
	char *funcname, *paramtype, *dllname,*strres;
	const int MAXPARAMCOUNT = 10;
	int paramcount,res1,restype,paramval,param_arr[MAXPARAMCOUNT],strbufsize,longres;
	IDispatch *pDisp;
    if (pArg == NULL)
	{
		acutPrintf("\nError: no arguments");
		return RTNORM;
	}
	if (pArg->restype != RTSTR)
	{
		acutPrintf("\nError: invalid argument Dllname");
		return RTNORM;
	}
	dllname=pArg->resval.rstring;

	pArg=pArg->rbnext;
    if (pArg == NULL)
	{
        acutPrintf("\nError: argument Funcname is absent");
		return RTNORM;
	}
    if (pArg->restype != RTSTR)
	{
		acutPrintf("\nError: invalid argument Funcname");
		return RTNORM;
	}
	funcname=pArg->resval.rstring;
	pArg=pArg->rbnext;
    if (pArg == NULL)
	{
        acutPrintf("\nError: parameters count is absent");
		return RTNORM;
	}
    if (pArg->restype != RTSHORT)
	{
		acutPrintf("\nError: invalid argument Paramcount");
		return RTNORM;
	}
	paramcount=int(pArg->resval.rint);
	if (MAXPARAMCOUNT < paramcount)
	{
		acutPrintf("\nError: Maximal parameter count exceeded");
		return RTNORM;
	}

//--------------------------------
	for(int i=0; i<paramcount;i++){
		pArg=pArg->rbnext;
		if (pArg == NULL)
		{
			acutPrintf("\nError: argument type expected");
			return RTNORM;
		}
		if (pArg->restype != RTSTR)
		{
			acutPrintf("\nError: invalid argument type");
			return RTNORM;
		}
		paramtype=pArg->resval.rstring;
//---------
		pArg=pArg->rbnext;
		if (pArg == NULL)
		{
			acutPrintf("\nError: argument expected");
			return RTNORM;
		}
		restype=pArg->restype;

		if (strcmpi(paramtype,"LONG")==0) 
		{
			if (restype==RTLONG)
				param_arr[i]=pArg->resval.rlong;
			else if (restype==RTSHORT) 
				param_arr[i]=int(pArg->resval.rint);
			else 
			{
				acutPrintf("\nError: \"LONG\" argument expected");
				return RTNORM;
			}
		}
		else if (strcmpi(paramtype,"STRING")==0) {
			if (restype==RTSTR)	param_arr[i]=int(pArg->resval.rstring);
			else 
			{
				acutPrintf("\nError: \"STRING\" argument expected");
				return RTNORM;
			}
		}	
		else if (strcmpi(paramtype,"STRRESULT")==0) {
			if (havestrres||havelongres)
			{
				acutPrintf("\nError: Only one \"RESULT\" argument allowed");
				return RTNORM;
			}
			if (restype==RTLONG) 
				strbufsize=pArg->resval.rlong;
			else if (restype==RTSHORT) 
				strbufsize=int(pArg->resval.rint);
			else
			{
				acutPrintf("\nError: Buffer size for \"STRRESULT\" argument expected");
				return RTNORM;
			}
			havestrres=true;
			if (0 >= strbufsize)
			{
				acutPrintf("\nError: Buffer size must be greater than 0");
				return RTNORM;
			}
			acutNewBuffer(strres, strbufsize); 
			//strres=new char[strbufsize];
			param_arr[i]=int(strres);
		}	
		else if (strcmpi(paramtype,"LONGRESULT")==0)
		{
			if (havestrres||havelongres) 
			{
				acutPrintf("\nError: Only one \"RESULT\" argument allowed");
				return RTNORM;
			}
			param_arr[i]=int(&longres);
			havelongres=true;
		}	
		else if (strcmpi(paramtype,"IACADAPP")==0) 
		{
			pDisp = acedGetAcadWinApp()->GetIDispatch(TRUE);
			param_arr[i]=int(pDisp);
		}	
		else
		{
			acutPrintf("\nError: invalid argument type \"%s\"", paramtype);
			return RTNORM;
		}
	}//for

    mylib=LoadLibrary(dllname);
	if (mylib==NULL) 
	{	
		acutPrintf("\nFailed to load %s", dllname);
		return RTNORM;
	}
	pFunc=(pUserFunc)GetProcAddress(mylib,funcname);
	if (pFunc==NULL)
	{
		FreeLibrary(mylib);
		acutPrintf("\nFailed to get adress of function \"%s\"", funcname);
		return RTNORM;
	}
	for(int j=paramcount-1; j>=0;j--){
		paramval=param_arr[j];
		_asm push paramval;
	}//for
	_asm{
		call DWORD PTR pFunc;
		mov	DWORD PTR res1,eax;
	}//asm
	if (havestrres) {
		res_list=acutNewRb(RTSTR);
		res_list->resval.rstring=strres;	
	}
	else {
		res_list=acutNewRb(RTLONG);
		if (havelongres) res_list->resval.rlong=longres;
		else res_list->resval.rlong=res1;
	}
	
	acedRetVal(res_list);

	acutRelRb(res_list);
	FreeLibrary(mylib);
	return RTNORM;
}

